## ksh 93u%2B

=== debian/changelog ===
ksh (93u+-1.2) testing-proposed-updates; urgency=low

  * Non-maintainer upload.
  * Fix handling of cd ../../.. and similar using
    the upstream changes from ee4582a commit, drop previous patch
    by Jonathan Wiltshire <jmw@debian.org> (Closes: #679966).

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Wed, 02 Jan 2013 18:41:22 +0100

ksh (93u+-1.1) testing-proposed-updates; urgency=low

  * Non-maintainer upload.
  * Fix handling of cd ../../.. and similar
    (cddotdot.patch, Closes: #679966)

 -- Jonathan Wiltshire <jmw@debian.org>  Sat, 13 Oct 2012 22:53:44 +0100

ksh (93u+-1) unstable; urgency=low

  * Bump to Standards-Version 3.9.3
  * New upstream release (closes: #636580, #667038)

 -- Oliver Kiddle <okiddle@yahoo.co.uk>  Sun, 15 Apr 2012 01:28:31 +0200
