=== debian/changelog ===
ksh (93u+20120801-3.4+deb10u1) buster; urgency=high

  * Fix for CVE-2019-14868: in ksh version 20120801, a flaw was found
    in the way it evaluates certain environment variables. An attacker
    could use this flaw to override or bypass environment restrictions
    to execute shell commands. Services and applications that allow
    remote unauthenticated attackers to provide one of those
    environment variables could allow them to exploit this issue
    remotely. (Closes: #948989)

 -- Anuradha Weeraman <anuradha@debian.org>  Sun, 12 Jul 2020 11:26:07 -0400

ksh (93u+20120801-3.4) unstable; urgency=medium

  [ Boyuan Yang ]
  * debian/menu: Replace menu entry with a .desktop file that only shows under Old menu systems
  * debian/rules: get-orig-source: Add notes about retrieving src
  * debian/watch: Add a watch file to monitor upstream version
  * debian/watch: Fix matching

  [ Aron Xu ]
  * Non-maintainer upload.
  * Fix FTBFS with glibc >= 2.28 by Juhani Numminen (Closes: #915326)

 -- Aron Xu <aron@debian.org>  Fri, 14 Dec 2018 15:26:58 +0800

ksh (93u+20120801-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Update Vcs-* fields and use git repo under Salsa
    Debian group.
  * debian/patches: Refresh last patch.
  * debian/changelog: Remove trailing spaces.

 -- Boyuan Yang <byang@debian.org>  Fri, 09 Nov 2018 10:52:17 -0500

ksh (93u+20120801-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build failures caused by update in glibc (Closes: #887743)

 -- Aron Xu <aron@debian.org>  Mon, 05 Nov 2018 17:46:13 +0800

ksh (93u+20120801-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * fix postinst with merged /usr using patch from mksh (Closes: #810158)

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 31 May 2017 11:57:56 +0200

ksh (93u+20120801-2) unstable; urgency=medium

  * Adopted package (Closes: #691199)
  * Created alioth git repository and added VCS fields
  * Removed Conflicts clause versus pdksh as it is no longer relevant
  * Marked RELEASE file as an upstream changelog rather than simply doc
  * Added lintian override explaining the absence of a watch file
  * Added patch to correct spelling errors
  * Raised standards version to 3.9.6 - no change
  * Raised compat level and debhelper version to 9
  * Revamped debian/rules and added hardening and reproducibility
  * Added binary format support for compiled scripts (Closes: #687343)
  * Reviewed package description - added note about shcomp
  * Registered with doc-base and added extra documents
  * Moved example.kshrc to /etc/skel/.kshrc
  * Reviewed cleanup-man-title.patch and enabled rksh
  * Small correction to formatting of man page (Closes: #755486)
  * Removed deprecated GREP_OPTIONS from example.kshrc
  * Removed SHLVL increment from example.kshrc as it was doubling increment
  * Rewrote setenv() in example.kshrc (Closes: #792733)
  * Reviewed copyright file and added license-reconcile config
  * Changed default fc editor to ex (Closes: #633524)

 -- Nicholas Bamber <nicholas@periapt.co.uk>  Mon, 02 Nov 2015 15:27:02 +0000

ksh (93u+20120801-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Removed extra files that had leaked into debian tarball, mea culpa

 -- Nicholas Bamber <nicholas@periapt.co.uk>  Tue, 27 Oct 2015 08:06:23 +0000

ksh (93u+20120801-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patch from bug report to resolve FTBS (Closes: #777930)

 -- Nicholas Bamber <nicholas@periapt.co.uk>  Fri, 16 Oct 2015 07:10:35 +0100

ksh (93u+20120801-1) unstable; urgency=low

  * New upstream release.
  * Support hardening compiler options.
  * Bump to Standards-Version 3.9.4.
  * Includes upstream fix to detect renamed parent directory. (closes: #686149)
  * cd built-in now properly fixed upstream. (Really Closes: #679966)

 -- Oliver Kiddle <okiddle@yahoo.co.uk>  Mon, 07 Jan 2013 16:08:49 +0100

ksh (93u+20120628-1) unstable; urgency=high

  * New upstream release (closes: #679966)

 -- Oliver Kiddle <okiddle@yahoo.co.uk>  Thu, 12 Jul 2012 05:41:59 +0200
