=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?(?:ksh)?v?([\da-zA-Z_.-]*)\.tar\.gz%ksh-$1.tar.gz%" \
 https://github.com/att/ast/tags \
 (?:.*?/)?v?(?:ksh)?([\da-zA-Z_.-]*)\.tar\.gz debian uupdate
