=== debian/control ===
--- 
+++ 
@@ -1,16 +1,25 @@
 Source: ksh
 Section: shells
 Priority: optional
-Maintainer: Nicholas Bamber <nicholas@periapt.co.uk>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Homepage: http://www.kornshell.com/
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9)
-Standards-Version: 3.9.6
+Build-Depends:
+ debhelper-compat (= 12),
+ dh-exec,
+ meson,
+ ninja-build,
+ locales-all,
+ procps,
+Standards-Version: 4.3.0
 Vcs-Git: https://salsa.debian.org/debian/ksh.git
 Vcs-Browser: https://salsa.debian.org/debian/ksh
 
 Package: ksh
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, binfmt-support
+Depends:
+ binfmt-support,
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Real, AT&T version of the Korn shell
  Ksh is a UNIX command interpreter (shell) that is intended for both
  interactive and shell script use. Its command language is a superset of
